mysite/mysite/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('enquetes.urls')),
    path('prova/', include('prova1.urls')),
    path('vagasifrn/', include('vagasifrn.urls')),
    path('accounts/', include('django.contrib.auth.urls')),
]

mysite/vagasifrn/urls.py
from django.urls import path
from . import views

app_name = 'vagasifrn'
urlpatterns = [
    path('', views.VagasView.as_view(), name='index'),
    path('perfil/', views.DefinePerfilView.as_view(), name='perfil'),
    path('direx/', views.PainelExtensaoView.as_view(), name='direx'),
    path('instituicao/', views.PainelEmpresaView.as_view(), name='instituicao'),
    path('vaga/add/', views.NovaVagaView.as_view(), name='vaga_add'),
    path('vaga/<int:pk>/', views.DetalhesVagaView.as_view(), name='vaga'),
    path('vaga/<int:pk>/edit/', views.EdicaoVagaView.as_view(), name='vaga_edit'),
    path('vaga/<int:pk>/valida/', views.ValidaVagaView.as_view(), name='vaga_valid'),
    path('cursos/', views.CursosView.as_view(), name='lista_cursos'),
    path('cursos/add/', views.NovoCursoView.as_view(), name='curso_add'),
    path(
        'instituicao/add/',
        views.NovaInstituicaoView.as_view(), name='instituicao_add'
    ),
]

mysite/vagasifrn/models.py
from django.contrib.auth.models import User
from django.db import models
from django.forms import ModelForm, Textarea, CheckboxSelectMultiple, DateInput

## Classe representando um servidor da DIREX
##-------------------------------------------
class Servidor(models.Model):
    class Meta():
        verbose_name_plural = 'servidores'
    matricula = models.IntegerField()
    user = models.OneToOneField(
        User, unique=True, null=True, on_delete=models.SET_NULL
    )
    def __str__(self):
        return self.matricula

## Classe representando uma instituição parceira
##-----------------------------------------------
class InstituicaoParceira(models.Model):
    class Meta():
        verbose_name_plural = 'instituições parceiras'
    nome = models.CharField(max_length = 40, unique = True)
    endereco = models.CharField(max_length = 100)
    eh_valida = models.BooleanField(default=False)
    user = models.OneToOneField(
        User, unique=True, null=True, on_delete=models.SET_NULL
    )
    def __str__(self):
        return self.nome
    def possui_vagas(self):
        return self.vagas_set.count() > 0
    def vagas_a_validar(self):
        return self.vagas_set.filter(validada = False).count()
    def vagas_validas(self):
        return self.vagas_set.all().filter(validada = True)
    def vagas_nao_validas(self):
        return self.vagas_set.all().filter(validada = False)

## Classe representando um curso da instituição
##----------------------------------------------
class Curso(models.Model):
    AREA = [
        ('gti', 'Gestão e Tencologia da Informação'),
        ('cci', 'Construção Civil'),
        ('ind', 'Indústria'),
    ]
    nome = models.CharField(max_length = 20, unique = True)
    area = models.CharField(max_length = 3, choices = AREA)
    def __str__(self):
        return self.nome

## Classe representando uma publicação de vagas de uma dada instituição
##----------------------------------------------------------------------
class Vagas(models.Model):
    instituicao_parceira = models.ForeignKey(
        InstituicaoParceira, on_delete = models.CASCADE
    )
    cursos = models.ManyToManyField(Curso, verbose_name='Cursos associados')
    funcao = models.CharField('Função', max_length = 50)
    prerequisitos = models.CharField('Pré-requisitos', max_length = 200)
    num_vagas = models.IntegerField('Número de vagas', default = 1)
    vagas_ocupadas = models.IntegerField(default = 0)
    banner = models.ImageField(upload_to = 'vagas', null = True, blank = True)
    data_pub = models.DateField('Data de publicação', auto_now_add = True)
    data_limite = models.DateField(null = True, blank = True)
    validada = models.BooleanField(default = False)
    remuneracao = models.DecimalField('Remuneração', max_digits=10, decimal_places=2)
    def preenchida(self):
        return self.num_vagas == self.vagas_ocupadas
    def disponivel(self):
        return self.num_vagas - self.vagas_ocupadas

class VagasForm(ModelForm):
    class Meta:
        model = Vagas
        fields = [
            'funcao', 'remuneracao', 'prerequisitos', 'num_vagas',
            'cursos', 'banner', 'data_limite'
        ]
        widgets = {
            'prerequisitos': Textarea(attrs={"cols": 70, "rows": 3}),
            'cursos': CheckboxSelectMultiple(),
            'data_limite': DateInput(attrs=dict(type='date'))
        }

mysite/vagasifrn/views.py
from django.shortcuts import render, redirect
from django.urls import reverse
from django.utils.decorators import method_decorator
from django.contrib.auth.decorators import login_required, user_passes_test
from django.contrib import messages
from django.http import HttpResponseRedirect, Http404
from django.views import View
from .services import CursoService, VagasService, InstituicaoService
from .models import VagasForm

####
## Testes para usuários logados
################################
def eh_parceira(user):
    return hasattr(user, 'instituicaoparceira')

def eh_parceira_valida(user):
    if hasattr(user, 'instituicaoparceira'):
        return user.instituicaoparceira.eh_valida
    return False

def eh_servidor(user):
    return hasattr(user, 'servidor')

####
## Classes de Visão
####################

## Classe para adição de uma nova instituição
##--------------------------------------------
class NovaInstituicaoView(View):
    def get(self, request, *args, **kwargs):
        return render(request, 'vagasifrn/form_instituicao.html')

    def post(self, request, *args, **kwargs):
        ips = InstituicaoService()
        inserida = ips.add_instituicao(request)
        if inserida:
            return redirect('vagasifrn:instituicao')
        return render(request, 'vagasifrn/form_instituicao.html')

## Classe para visualização de DETALHES de uma dada vaga
##-------------------------------------------------------
class DetalhesVagaView(View):
    def get(self, request, *args, **kwargs):
        vs = VagasService()
        vaga = vs.get_vaga(kwargs)
        return render(request, 'vagasifrn/vaga.html', {'vaga': vaga})

## Clase para ADIÇÃO de uma nova vaga
##------------------------------------
@method_decorator(user_passes_test(eh_parceira), name='dispatch')
class NovaVagaView(View):
    def get(self, request, *args, **kwargs):
        form = VagasForm()
        return render(request, 'vagasifrn/form_vaga.html', {'form': form})

    def post(self, request, *args, **kwargs):
        vs = VagasService()
        form = vs.add_vaga(request)
        if form == None:
            return redirect('vagasifrn:instituicao')
        return render(request, 'vagasifrn/form_vaga.html', {'form': form})

## Clase para EDIÇÃO de vaga cadastrada
##--------------------------------------
@method_decorator(user_passes_test(eh_parceira), name='dispatch')
class EdicaoVagaView(View):
    def get(self, request, *args, **kwargs):
        vs = VagasService()
        vaga = vs.get_vaga(kwargs)
        if vaga == None:
            raise Http404('Identificação de vaga inválida!')
        form = VagasForm(instance = vaga)
        contexto = {'form': form, 'edit': True, 'vaga_id': vaga.id}
        return render(request, 'vagasifrn/form_vaga.html', contexto)

    def post(self, request, *args, **kwargs):
        vs = VagasService()
        form = vs.edit_vaga(request, kwargs)
        if form == None:
            return redirect('vagasifrn:instituicao')
        vaga_id = kwargs.get('pk', -1)
        contexto = {'form': form, 'edit': True, 'vaga_id': vaga_id}
        return render(request, 'vagasifrn/form_vaga.html', contexto)

## Classe que identifica o tipo de usuário logado
##------------------------------------------------
@method_decorator(login_required, name='dispatch')
class DefinePerfilView(View):
    def get(self, request, *args, **kwargs):
        if hasattr(request.user, 'servidor'):
            return redirect('vagasifrn:direx')
        elif hasattr(request.user, 'instituicaoparceira'):
            return redirect('vagasifrn:instituicao')
        messages.error(request, 'Usuário logado é inválido, use um usuário válido!')
        return redirect('login')

## Classe que apresenta a tela inicial para servidores da DIREX
##--------------------------------------------------------------
@method_decorator(user_passes_test(eh_servidor), name='dispatch')
class PainelExtensaoView(View):
    def get(self, request, *args, **kwargs):
        ips = InstituicaoService()
        return render(request, 'vagasifrn/direx.html', {'service': ips})

## Classe responsável para tornar uma vaga "válida"
##--------------------------------------------------
@method_decorator(user_passes_test(eh_servidor), name='dispatch')
class ValidaVagaView(View):
    def get(self, request, *args, **kwargs):
        vs = VagasService()
        vs.valida_vaga(request, kwargs)
        return redirect('vagasifrn:direx')


## Classe que apresenta a tela inicial para empresas parceiras
##-------------------------------------------------------------
@method_decorator(user_passes_test(eh_parceira), name='dispatch')
class PainelEmpresaView(View):
    def get(self, request, *args, **kwargs):
        return render(request, 'vagasifrn/instituicao.html')

## Classe que apresenta a tela inicial da aplicação - vagas caadastradas
##-----------------------------------------------------------------------
class VagasView(View):
    def get(self, request, *args, **kwargs):
        vs = VagasService()
        vagas = vs.get_all()
        return render(request, 'vagasifrn/index.html', {'vagas': vagas})

## Classe que apresenta os cursos cadastrados
##--------------------------------------------
@method_decorator(user_passes_test(eh_servidor), name='dispatch')
class CursosView(View):
    def get(self, request, *args, **kwags):
        cs = CursoService()
        cursos = cs.get_all()
        return render(request, 'vagasifrn/cursos.html', {'cursos': cursos})

## Classe responsável pelo cadastramento de um novo curso
##--------------------------------------------------------
@method_decorator(user_passes_test(eh_servidor), name='dispatch')
class NovoCursoView(View):
    def get(self, request, *args, **kwags):
        return render(request, 'vagasifrn/form_curso.html')

    def post(self, request, *args, **kwags):
        cs = CursoService()
        inserido = cs.add_curso(request)
        if inserido:
            return HttpResponseRedirect(reverse('vagasifrn:lista_cursos'))
        else:
            return render(request, 'vagasifrn/form_curso.html')

mysite/vagasifrn/templates/vagasifrn/base.html
<html>
    <head>
        <title>Vagas @ IFRN</title>
    </head>
    <body>
        <h1>Divulgação de Oportunidades de Trabalho</h1>
        <h2>para os alunos e egressos do campus Natal Central do IFRN</h2>
        {% block mensagens %}
        {% if messages %}
            <ul class="messages">
            {% for message in messages %}
                <li{% if message.tags %} class="{{ message.tags }}"{% endif %}>{{ message }}</li>
            {% endfor %}
            </ul>
        {% endif %}
        {%endblock%}

        <hr/>
        <h2>{% block titulo %}{% endblock %}</h2>

        {% block principal %}
        {% endblock %}

        {% block menu %}
            <hr/>
            {% if user.instituicaoparceira %}
                <a href="{% url 'vagasifrn:instituicao' %}">Home</a>
            {% elif user.servidor %}
                <a href="{% url 'vagasifrn:direx' %}">Home</a>
            {% else %}
                <a href="{% url 'vagasifrn:index' %}">Home</a>
            {% endif %}
            {% if user.is_authenticated %}
                | Logado como: {{ user.username }}
                {% if user.servidor %}
                    ({{ user.servidor.matricula }})
                {% endif %}
                (<a href="{% url 'logout' %}?next={% url 'vagasifrn:index' %}">logout</a>)
            {% else %}
                | <a href="{% url 'login' %}?next={% url 'vagasifrn:perfil' %}">Faça o seu login</a>
            {% endif %}
            {% block novos_itens %}
            {% endblock %}
        {% endblock %}
    </body>
</html>

mysite/vagasifrn/templates/vagasifrn/cursos.html
{% extends 'vagasifrn/base.html' %}
{% block titulo %}Listagem dos Cursos do Campus Natal Central do IFRN{% endblock %}

{% block principal %}
    {% if cursos %}
    <ul>
        {% for curso in cursos %}
            <li>{{ curso.nome }} da área de
            {{ curso.get_area_display }}</li>
        {% endfor %}
    </ul>
    {% else %}
        <h3>Nenhum curso cadastrado até o momento!</h3>
    {% endif %}
{% endblock %}

{% block novos_itens %}
    | <a href="{% url 'vagasifrn:curso_add' %}">(+) Novo Curso</a>
{% endblock %}

mysite/vagasifrn/templates/vagasifrn/direx.html
{% extends 'vagasifrn/base.html' %}

{% block titulo %}Painel da Diretoria de Extensão{% endblock %}

{% block principal %}
    <h3>Empresas Parceiras a serem Validadas:</h3>
    {% if service.possui_invalidas %}
        <ul>
        {% for instituicao in service.get_invalidas %}
            <li><b>{{ instituicao.nome }}</b>
            (<a href="#">ver detalhes</a>
            | <a href="#">validar</a>)</li>
        {% endfor %}
        </ul>
    {% else %}
        <p><i>Nenhuma Empresa Parceira a validar!</i></p>
    {% endif %}

    <h3>Lista das Empresas Parceiras Validadas:</h3>
    {% if service.possui_validas %}
        <ul>
        {% for instituicao in service.get_validas %}
            <li>
                <b>{{ instituicao.nome }}</b>
                (<a href="#">ver detalhes</a>)
                {% if instituicao.vagas_a_validar > 0 %}
                    - <b>com {{ instituicao.vagas_a_validar }}
                    vaga{{ instituicao.vagas_a_validar | pluralize }}
                    a validar!</b>
                {% endif %}
            </li>
            {% if instituicao.vagas_nao_validas %}
                <ul>
                    {% for vaga in instituicao.vagas_nao_validas %}
                        <li>
                            {{ vaga.num_vagas }} vagas para {{ vaga.funcao }},
                            com remuneração de R$ {{ vaga.remuneracao }}
                            (<a href="{% url 'vagasifrn:vaga' vaga.id %}">ver detalhes</a>
                             para validar)
                        </li>
                    {% endfor %}
                </ul>
            {% endif %}
        {% endfor %}
        </ul>
    {% else %}
        <p><i>Nenhuma Empresa Parceira validada!</i></p>
    {% endif %}
{% endblock %}

mysite/vagasifrn/templates/vagasifrn/form_curso.html
{% extends 'vagasifrn/base.html' %}

{% block titulo %}Cadastramento de Curso{% endblock %}

{% block principal %}
    <form method="post" action="{% url 'vagasifrn:curso_add' %}">
        {% csrf_token %}
        <p>Nome: <input type="text" size="70" name="nome"/></p>
        <p>
            Área: <select name="area">
                <option value="gti">Gestão e Tencologia da Informação</option>
                <option value="cci">Construção Civil</option>
                <option value="ind" selected>Indústria</option>
            </select>
        </p>
        <input type="submit" value="Cadastrar o Curso"/>
    </form>
{% endblock %}

mysite/vagasifrn/templates/vagasifrn/form_instituicao.html
{% extends 'vagasifrn/base.html' %}

{% block titulo %}Cadastramento de Instituição Parceira{% endblock %}

{% block principal %}
    <form method="post" action="{% url 'vagasifrn:instituicao_add' %}">
        {% csrf_token %}
        <p>Nome: <input type="text" size="70" name="nome" required/></p>
        <p>Endereço: <input type="text" size="80" name="end"/></p>
        <p><b>Informações para Login no Sistema:</b></p>
        <p>Login: <input type="text" name="login"/></p>
        <p>Senha: <input type="password" name="senha1"/></p>
        <p>Senha*: <input type="password" name="senha2"/>
        (repetir a mesma senha, para confirmação)</p>
        <p>E-mail: <input type="email" name="email"/></p>
        <input type="submit" value="Cadastrar a Instituição"/>
    </form>
{% endblock %}

mysite/vagasifrn/templates/vagasifrn/form_vaga.html
{% extends 'vagasifrn/base.html' %}

{% block titulo %}Cadastramento de Vaga{% endblock %}

{% block principal %}
    <form method="post" enctype="multipart/form-data"
        {% if edit %}
            action="{% url 'vagasifrn:vaga_edit' vaga_id %}">
        {% else %}
            action="{% url 'vagasifrn:vaga_add' %}">
        {% endif %}
        {% csrf_token %}
        {{ form.as_p }}
        {% if edit %}
            <input type="submit" value="Atualizar Vaga"/>
        {% else %}
            <input type="submit" value="Cadastrar nova Vaga"/>
        {% endif %}
    </form>
{% endblock %}

mysite/vagasifrn/templates/vagasifrn/index.html
{% extends 'vagasifrn/base.html' %}

{% block titulo %}Listagem das Vagas Cadastradas{% endblock %}

{% block principal %}
    {% if vagas %}
        <ul>
        {% for vaga in vagas %}
            <li><a href="{% url 'vagasifrn:vaga' vaga.id %}">
            {{ vaga.num_vagas }} vagas para {{ vaga.funcao }},
            com uma remurenação de R$ {{ vaga.remuneracao }}
            </a></li>
        {% endfor %}
        </ul>
    {% else %}
        <h3>Nenhuma vaga cadastrada até o momento!</h3>
    {% endif %}
{% endblock %}

{% block novos_itens %}
    | <a href="{% url 'vagasifrn:instituicao_add' %}">Cadastro de instituição parceira</a>
{% endblock %}

mysite/vagasifrn/templates/vagasifrn/instituicao.html
{% extends 'vagasifrn/base.html' %}

{% block titulo %}
Painel da Instituição Parceira: {{ user.instituicaoparceira.nome }}
{% endblock %}

{% block principal %}
    {% if user.instituicaoparceira.eh_valida %}
        <h3>Listagem das Vagas Cadastradas:</h3>
        {% if user.instituicaoparceira.possui_vagas %}
          <h4>Lista das Vagas validadas pelo IFRN:</h4>
          {% if user.instituicaoparceira.vagas_validas %}
            <ul>
                {% for vaga in user.instituicaoparceira.vagas_validas %}
                <li>
                    {{ vaga.num_vagas }} vagas para {{ vaga.funcao }},
                    com remuneração de R$ {{ vaga.remuneracao }}
                    {% if vaga.preenchida %}
                        (<b>VAGAS PREENCHIDAS</b>)
                    {% else %}
                        (<a href="{% url 'vagasifrn:vaga' vaga.id %}">ver detalhes</a>
                        | <a href="{% url 'vagasifrn:vaga_edit' vaga.id %}">editar</a>)
                    {% endif %}
                </li>
                {% endfor %}
            </ul>
          {% else %}
            <dd>Nenhuma vaga validada até o momento.</dd>
          {% endif %}
          <h4>Lista das Vagas ainda NÃO validadas pelo IFRN:</h4>
          {% if user.instituicaoparceira.vagas_nao_validas %}
            <ul>
                {% for vaga in user.instituicaoparceira.vagas_nao_validas %}
                <li>
                    {{ vaga.num_vagas }} vagas para {{ vaga.funcao }},
                    com remuneração de R$ {{ vaga.remuneracao }}
                    {% if vaga.preenchida %}
                        (<b>VAGAS PREENCHIDAS</b>)
                    {% else %}
                        (<a href="{% url 'vagasifrn:vaga' vaga.id %}">ver detalhes</a>
                        | <a href="{% url 'vagasifrn:vaga_edit' vaga.id %}">editar</a>)
                    {% endif %}
                </li>
                {% endfor %}
            </ul>
          {% else %}
            <dd>Nenhuma vaga a ser validada no presente momento.</dd>
          {% endif %}
        {% else %}
            <dd><i>Nenhuma vaga cadastrada até o momento!</i></dd>
        {% endif %}
        <p>
            <a href="{% url 'vagasifrn:vaga_add' %}">(+) cadastrar nova VAGA</a>
        </p>
    {% else %}
        <h3>Instituição aguardando validação do IFRN!</h3>
    {% endif %}
{% endblock %}

mysite/vagasifrn/templates/vagasifrn/vaga.html
{% extends 'vagasifrn/base.html' %}

{% block titulo %}Detalhamento de Vaga{% endblock %}

{% block principal %}
    <table border="0">
        <tr>
            <td><img src="{{ vaga.banner.url }}" width="90%"/></td>
            <td>
                <p><b>Instituição Parceira</b>: {{ vaga.instituicao_parceira }}</p>
                <p><b>Função</b>: {{ vaga.funcao }}</p>
                <p><b>Remuneração</b>: R$ {{ vaga.remuneracao }}</p>
                <p><b>Pré-requisitos</b>: {{ vaga.prerequisitos }}</p>
                <p><b>Cursos associados</b>:
                {% for curso in vaga.cursos.all %}
                    <dd>{{ curso.nome }}</dd>
                {% endfor %}
                </p>
                <p><b>Data de publicação</b>: {{ vaga.data_pub | date:"d/m/Y" }}</p>
                <p><b>Data limite</b>: {{ vaga.data_limite | date:"d/m/Y" }}</p>
                <p><b>Quantidade de vagas</b>: {{ vaga.num_vagas }}</p>
                <p><b>Vagas ocupadas</b>: {{ vaga.vagas_ocupadas }}</p>
                {% if user.servidor and not vaga.validada %}
                    <button onclick="confirm_validacao()">Validar Vaga</button>
                {% elif user.instituicaoparceira and user.instituicaoparceira == vaga.instituicao_parceira %}
                    <a href="{% url 'vagasifrn:vaga_edit' vaga.id %}">
                        <button>EDITAR</button>
                    </a>
                    &nbsp;&nbsp;&nbsp;
                    <a href="#"><button>REMOVER</button></a>
                {% endif %}
            </td>
        </tr>
    </table>

    <script>
        function confirm_validacao() {
            let text = "Confirma que deseja validar esta vaga?";
            if (confirm(text) == true) {
                open("{% url 'vagasifrn:vaga_valid' vaga.id %}", "_self");
            } else {
            }
        }
    </script>
{% endblock %}